'Ausgabe-Ports definieren
define Lampe1   port[1]      'Lampe1
define Lampe2   port[2]      'Lampe2
define Lampe3   port[3]      'Lampe3
define Heizer   port[4]      'Heizung
define Dnger   port[5]      'Pumpe fr Dnger
define Res2Port port[6]      'defektes Relais
define UVLampe  port[7]      'UV-Lampe
define CO2      port[8]      'Magnetventil f. CO2

'Analogports definieren
define Temp  ad[1]
define Ph    ad[2]
define Leit  ad[3]
define Pegel ad[4]

'Systemvariablen definieren
define LastSec byte
define LastMin byte
define Zeile byte
define Command byte
define Value byte
define Lampe1On byte
define Lampe1Off byte
define Lampe2On byte
define Lampe2Off byte
define Lampe3On byte
define Lampe3Off byte
define UVLampeOn byte
define UVLampeOff byte
define DngerOn byte
define DngerHold byte
define TempMin byte
define TempMax byte
define PhMin byte
define PhMax byte
define PegMin byte
define PegMax byte
define OldLeit byte
define lcd_buf byte
define lcd_param byte

' *** Definition LCD-Ports ***
define lcd_port byteport[2]
define lcd_rs port[14]
define lcd_rw port[13]
define lcd_e  port[15]
define lcd_e2 port[16]

'-------------------------------------------------------------

'*** ASCII-Codes ***
define A_ &H41
define E_ &H45
define ki_ &H69
define kn_ &H6E
define S_ &H53
define ks_ &H73
define ku_ &H75
define V_ &H56
define W_ &H57
define kw_ &H77
define kz_ &H7A
define LEERZ &H20
define MINUS &H2D
define GLEICH &H3D
define DOPPELPUNKT &H3A
define PUNKT &H2E
define Grad &HDF
define NULL &H30
define My &HE4
define L_ &H4C
define Eins_ &H31

'-------------------------------------------------------------
'Defaultwerte initialisieren
define EndByte 255
define BlockSize 8
Lampe1=off
Lampe2=off
Lampe3=off
UVLampe=off
Dnger=off
CO2=off
Res2Port=off
lastsec=0
lastmin=99


' ***********************************************************************
' *** Hauptprogramm *****************************************************
' ***********************************************************************

'Schaltzeiten/-Werte laden
  open# for read
    if eof then Lampe1On=120  else input# Lampe1On
    if eof then Lampe1Off=220 else input# Lampe1Off
    if eof then Lampe2On=140  else input# Lampe2On
    if eof then Lampe2Off=200 else input# Lampe2Off
    if eof then Lampe3On=121  else input# Lampe3On
    if eof then Lampe3Off=221 else input# Lampe3Off
    if eof then UVLampeOn=220 else input# UVLampeOn
    if eof then UVLampeOff=70 else input# UVLampeOff
    if eof then DngerOn=100  else input# DngerOn
    if eof then DngerHold=3  else input# DngerHold
    if eof then TempMin=40    else input# TempMin     'jeweils +200
    if eof then TempMax=60    else input# TempMax     'jeweils +200
    if eof then PhMin=6       else input# PhMin
    if eof then PhMax=7       else input# PhMax
    if eof then PegMin=0      else input# PegMin
    if eof then PegMax=0      else input# PegMax
    if eof then value=1 else value=0
  close#
  if value=1 then  gosub SaveConfigData

  gosub LCD_INIT
  beep 250,30,5

#MainLoop
  wait second <> lastsec
  lastsec = second
  gosub WriteDateTime
  'Sub Schaltzeiten berprfen
    if (hour * 100 + minute >= Lampe1On   * 10) AND (hour * 100 + minute < Lampe1Off * 10) then Lampe1=on else Lampe1=off
    if (hour * 100 + minute >= Lampe2On   * 10) AND (hour * 100 + minute < Lampe2Off * 10) then Lampe2=on else Lampe2=off
    if (hour * 100 + minute >= Lampe3On   * 10) AND (hour * 100 + minute < Lampe3Off * 10) then Lampe3=on else Lampe3=off
    if (hour * 100 + minute >= UVLampeOff * 10) then UVLampe=off
    if (hour * 100 + minute >= UVLampeOn  * 10) then UVLampe=on
    if (hour * 100 + minute = DngerOn * 10) AND Second<3 then gosub Duenger
  'Temperatur messen und auf berlauf prfen und Heizung schalten
  looktab TempTab, Temp, value 'da zu value, TempMax u. TempMin 200 addiert werden mssen kann man krzen
  if (value  => TempMax AND Heizer=On) OR value = 0 then Heizer=Off
  if value  <= TempMin AND Heizer=Off AND value <> 0 then Heizer=On
  if Temp < 1 Or Temp > 253 And Second < 3 then gosub ErrorBeep
  'Ph messen und O2-Pumpe schalten
  looktab PhTab, Ph, value
  if value => PhMax Then CO2=On
  if value <= PhMin Then CO2=Off
  gosub WriteTemp
  gosub WritePh
  gosub WriteLeit
  gosub WriteLicht
  'if minute<>lastmin Then gosub Logger 'Nur fr Loggertest aktivieren!
  if minute=0 AND minute<>lastmin and year<10 Then gosub Logger
  if (minute=0 or minute=30) AND minute<>lastmin then gosub LCD_INIT
  if RxD then gosub SubRxD
  lastmin=minute
goto MainLoop


'************************************************************************
'Sub Dngerpumpe fr Zeit DngerHold einschalten
#Duenger
   Dnger=on
   pause DngerHold*1000/20
   Dnger=off
return

'************************************************************************
'Sub fr 3 kurze Piepstne als Fehlermeldung
#ErrorBeep
  Beep 50,10,1
  Beep 50,10,1
  beep 50,10,1
return

'************************************************************************
'*** LCD - Ausgaben *****************************************************
'************************************************************************
'Sub Datum/Uhrzeit auf LCD ausgeben
#WriteDateTime
  zeile=1
  lcd_param=1                       : gosub LCD_GOTOLINE
  for value=0 to 6
      looktab LCDTexte, value, lcd_param
      gosub LCD_WRITECHAR
  next value
  lcd_param = NULL + day / 10       : gosub LCD_WRITECHAR
  lcd_param = NULL + day mod 10     : gosub LCD_WRITECHAR
  lcd_param = PUNKT                 : gosub LCD_WRITECHAR
  lcd_param = NULL + month / 10     : gosub LCD_WRITECHAR
  lcd_param = NULL + month mod 10   : gosub LCD_WRITECHAR
  lcd_param = PUNKT                 : gosub LCD_WRITECHAR
  lcd_param = NULL + year / 10      : gosub LCD_WRITECHAR
  lcd_param = NULL + year mod 10    : gosub LCD_WRITECHAR
  for value=7 to 19
      looktab LCDTexte, value, lcd_param
      gosub LCD_WRITECHAR
  next value
  lcd_param = NULL + hour / 10      : gosub LCD_WRITECHAR
  lcd_param = NULL + hour mod 10    : gosub LCD_WRITECHAR
  lcd_param = DOPPELPUNKT           : gosub LCD_WRITECHAR
  lcd_param = NULL + minute / 10    : gosub LCD_WRITECHAR
  lcd_param = NULL + minute mod 10  : gosub LCD_WRITECHAR
  lcd_param = DOPPELPUNKT           : gosub LCD_WRITECHAR
  lcd_param = NULL + second / 10    : gosub LCD_WRITECHAR
  lcd_param = NULL + second mod 10  : gosub LCD_WRITECHAR
return

'Sub Temperatur auf LCD ausgeben
#WriteTemp
  Zeile=2
  lcd_param = 2                                : gosub LCD_GOTOLINE        ' Wechsel in die zweite Zeile
  for value=20 to 30
      looktab LCDTexte, value, lcd_param
      gosub LCD_WRITECHAR
  next value
  looktab TempTab, Temp, value
  lcd_param = Null + (200 + value) / 100       : gosub LCD_WRITECHAR
  lcd_param = Null + ((200 + value) mod 100)/10: gosub LCD_WRITECHAR
  lcd_param=Punkt                              : gosub LCD_WRITECHAR
  lcd_param = Null + (200 + value) mod 10      : gosub LCD_WRITECHAR
  for value=31 to 42
    looktab LCDTexte, value, lcd_param
    gosub LCD_WRITECHAR
  next value
  if Heizer=On then gosub EIN else gosub Aus
return

'Sub Ph-Wert auf LCD ausgeben
#WritePh
  Zeile=3
  lcd_param = 1                         : gosub LCD_GOTOLINE
  for value=43 to 50
      looktab LCDTexte, value, lcd_param
      gosub LCD_WRITECHAR
  next value
  looktab PhTab, Ph, value
  IF Value > 99 Then lcd_param = NULL + (value / 100 )  ELSE lcd_param =&H20 : gosub LCD_WRITECHAR
  lcd_param = NULL + (value mod 100)/10 : gosub LCD_WRITECHAR
  lcd_param=Punkt                       : gosub LCD_WRITECHAR
  lcd_param = NULL + value mod 10       : gosub LCD_WRITECHAR
return

'Sub Leitwert auf LCD ausgeben
#WriteLeit
  for value=51 to 66
      looktab LCDTexte, value, lcd_param
      gosub LCD_WRITECHAR
  next value
  if OldLeit <> 0 then value = (oldleit+leit)/2
  oldleit=value
  goto MB4

 'zum Test
  lcd_param= Null + Leit / 100      : gosub LCD_WRITECHAR
  lcd_param = NULL+(Leit mod 100)/10: gosub LCD_WRITECHAR
  lcd_param = NULL + Leit mod 10    : gosub LCD_WRITECHAR
  goto EndWriteLeit

  #MB3
  'Der Faktor 4 ergibt sich bei Mebereich 3 mit 1000S Endwert (1000/250=4)
  if (value * 4) > 999 then lcd_param = NULL + (value * 4) / 1000 ELSE lcd_param =&H20
  gosub LCD_WRITECHAR
  if (value * 4) >  99 then lcd_param = NULL + ((value * 4) mod 1000) / 100 ELSE lcd_param =&H20
  gosub LCD_WRITECHAR
  if (value * 4) >   9 then lcd_param = NULL + ((value * 4) mod 100) / 10 ELSE lcd_param =&H20
  gosub LCD_WRITECHAR
  lcd_param = NULL + (value * 4) mod 10
  gosub LCD_WRITECHAR
  goto EndWriteLeit

  #MB4
  'Der Faktor 12/10 ergibt sich bei Mebereich 4 mit 300S Endwert (300/250=1,2)
  if (value * 12/10) > 999 then lcd_param = NULL + (value * 12/10) / 1000 ELSE lcd_param =&H20
  gosub LCD_WRITECHAR
  if (value * 12/10) >  99 then lcd_param = NULL + ((value * 12/10) mod 1000) / 100 ELSE lcd_param =&H20
  gosub LCD_WRITECHAR
  if (value * 12/10) >   9 then lcd_param = NULL + ((value * 12/10) mod 100) / 10 ELSE lcd_param =&H20
  gosub LCD_WRITECHAR
  lcd_param = NULL + (value * 12/10) mod 10
  gosub LCD_WRITECHAR
  goto EndWriteLeit

  #EndWriteLeit
  lcd_param=My   : gosub LCD_WRITECHAR
  lcd_param=S_   : gosub LCD_WRITECHAR
return

'Sub Zustand der Lampen-Ports auf LCD schreiben
#WriteLicht
  Zeile=4
  lcd_param = 2                     : gosub LCD_GOTOLINE
  for value=67 to 75
      looktab LCDTexte, value, lcd_param
      gosub LCD_WRITECHAR
  next value
  if UVLampe=on then gosub EIN else gosub AUS
  for value=76 to 80
      looktab LCDTexte, value, lcd_param
      gosub LCD_WRITECHAR
  next value
  if Lampe1=on then gosub EIN else gosub AUS
  for value=81 to 85
      looktab LCDTexte, value, lcd_param
      gosub LCD_WRITECHAR
  next value
  if Lampe2=on then gosub EIN else gosub AUS
  for value=86 to 90
      looktab LCDTexte, value, lcd_param
      gosub LCD_WRITECHAR
  next value
  if Lampe3=on then gosub EIN else gosub AUS
return

'Sub "Ein" auf LCD an Curserposition ausgeben
#EIN
  lcd_param=E_                     : gosub LCD_WRITECHAR
  lcd_param=ki_                    : gosub LCD_WRITECHAR
  lcd_param=kn_                    : gosub LCD_WRITECHAR
return

'Sub "Aus" auf LCD an Curserposition ausgeben
#AUS
  lcd_param=A_                     : gosub LCD_WRITECHAR
  lcd_param=ku_                    : gosub LCD_WRITECHAR
  lcd_param=ks_                    : gosub LCD_WRITECHAR
return

'************************************************************************
'*** PC-Kommunikation ***************************************************
'************************************************************************
#SubRxD
  get Command
  if Command=65 then goto  SubRxD
  if Command=84 then goto  SubRxD
  if Command=0  then gosub ReadLoggerData       'Loggerdatei lesen
  if Command=1  then gosub ReadClock            'Uhrzeit lesen
  if Command=2  then gosub ReadCurrentValues    'aktuelle Medaten lesen
  if Command=4  then gosub ReadConfigData       'Konfiguration lesen
  if Command=8  then gosub GetConfigData1       '1 Block Konfigurationsdaten empfangen
  if Command=9  then gosub GetConfigData2       '2 Block Konfigurationsdaten empfangen
  if Command=10 then gosub GetConfigData3       '3 Block Konfigurationsdaten empfangen
  if Command=11 then gosub GetConfigData4       '4 Block Konfigurationsdaten empfangen
return

#ReadClock
  get Command
  if Command<>27 then return  '27=Startbyte
  put dow
  put day
  put month
  put year
  put hour
  put minute
  put second
  put EndByte
  put EndByte
return

#ReadCurrentValues
  get Command
  if Command<>27 then return  '27=Startbyte
  put hour
  put minute
  put second
  looktab TempTab, Temp, value
  put value
  looktab PhTab, Ph, value
  put value
  if Heizer=On then put 1 else put 0
  put Leit
  put Pegel
  put EndByte
  put EndByte
return

#ReadConfigData
  open# for read
    #NextRead
      input# Value
      if Value=Endbyte then goto EndRead
      put Value
      goto NextRead
    #EndRead
    put EndByte
    put EndByte
  close#
return

#GetConfigData1
  get Command
  if Command<>27 then return  '27=StartByte
  get Lampe1On
  get Lampe1Off
  get Lampe2On
  get Lampe2Off
      put Endbyte
      put Endbyte
return

#GetConfigData2
  get Command
  if Command<>27 then return  '27=StartByte
  get Lampe3On
  get Lampe3Off
  get UVLampeOn
  get UVLampeOff
      put Endbyte
      put Endbyte
return

#GetConfigData3
  get Command
  if Command<>27 then return  '27=StartByte
  get DngerOn
  get DngerHold
  get TempMin
  get TempMax
      put Endbyte
      put Endbyte
return

#GetConfigData4
  get Command
  if Command<>27 then return  '27=StartByte
  get PhMin
  get PhMax
  get PegMin
  get PegMax
      put Endbyte
      put Endbyte
  gosub SaveConfigData
return

#SaveConfigData
  open# for write
    print# Lampe1On
    print# Lampe1Off
    print# Lampe2On
    print# Lampe2Off
    print# Lampe3On
    print# Lampe3Off
    print# UVLampeOn
    print# UVLampeOff
    print# DngerOn
    print# DngerHold
    print# TempMin
    print# TempMax
    print# PhMin
    print# PhMax
    print# PegMin
    print# PegMax
    print# Endbyte
  close#
return

#Logger
  open# for append
    'lastmin=minute
    'if filefree<=BlockSize then goto BufferFull 'filefree funktioniert nicht mit grerem EEPROM
    print# day
    print# month
    print# year
    print# hour
    looktab TempTab, Temp, value
    print# value
    looktab PhTab, Ph, value
    print# value
    if Leit>253 then Leit=253
    print# Leit
    if Pegel>253 then Pegel=253
    print# 0 'Pegel
    close#
    return
   #BufferFull
    close#
    gosub ErrorBeep
return

#ReadLoggerData
  get command
  if command<>27 then return
  open# for Read
   #ReadHeader
    if eof then goto ReadingEnd
    input# value
    if value<>Endbyte then  goto ReadHeader
   #ReadData
    if eof then goto ReadingEnd
    pause 1
    input# value
    pause 1
    put value
    goto ReadData
   #ReadingEnd
    put Endbyte
    put EndByte
  close#
return

'************************************************************************
'*** LCD_Interface ******************************************************
'( muss in jedes Programm mit LCD-Ausgabe eingefuegt werden)
'************************************************************************
#LCD_INIT

' alle ports 0
  lcd_port = OFF

' 8-Bit-Modus aktivieren
  lcd_param=&H38
  zeile=1
  gosub LCD_WRITECMD
  zeile=3
  gosub LCD_WRITECMD

' mit 8-Bit-Command in 4-Bit-Modus umschalten
  lcd_port=&B00000010
  pulse lcd_e
  pulse lcd_e2

' ab jetzt 4-Bit-Modus
  lcd_param = &H28 : zeile=1 : gosub LCD_WRITECMD : zeile=3 : gosub LCD_WRITECMD
  lcd_param = &H0C : zeile=1 : gosub LCD_WRITECMD : zeile=3 : gosub LCD_WRITECMD

' Display loeschen
#LCD_CLS
  lcd_param = &H02 : zeile=1 : gosub LCD_WRITECMD : zeile=3 : gosub LCD_WRITECMD
  lcd_param = &H01 : zeile=1 : gosub LCD_WRITECMD : zeile=3 : gosub LCD_WRITECMD
return

' Zeilenwechsel
#LCD_GOTOLINE
  if lcd_param = 1 then lcd_param = &H80
  if lcd_param = 2 then lcd_param = &HC0
  goto LCD_WRITECMD

' LCD-Kommando
#LCD_WRITECMD
  lcd_buf = OFF
  goto LCD_WRITE

' Zeichenausgabe
#LCD_WRITECHAR
  lcd_buf = &B00100000

' Kommando oder Zeichen an Display senden
#LCD_WRITE
  lcd_port = lcd_buf or (lcd_param shr 4) ' Hi-Nibble
  if zeile<3 then pulse lcd_e else pulse lcd_e2
  lcd_port = lcd_buf or (lcd_param and &H0F)  ' Lo-Nibble
  if zeile<3 then pulse lcd_e else pulse lcd_e2
return

End

'*******************************************************************************
'*** Tabellen ******************************************************************
'*******************************************************************************

Table LCDTexte
  &H44 &H61 &H74 &H75 &H6D &H3A &H20 'Datum:_ '0-6
  &H20 &H20 &H20 &H20 &H55 &H68 &H72 &H7A &H65 &H69 &H74 &H3A &H20  '____Uhrzeit:_ '7-19
  &H54 &H65 &H6D &H70 &H65 &H72 &H61 &H74 &H75 &H72 &H3D 'Temperatur= '20-30
  &HDF &H43 &H20 &H20 &H48 &H65 &H69 &H7A &H75 &H6E &H67 &H3D 'C__Heizung= '31-42
  &H50 &H68 &H2D &H57 &H65 &H72 &H74 &H3D 'Ph-Wert= '43-50
  &H20 &H20 &H20 &H20 &H20 &H20 &H20 &H4C &H65 &H69 &H74 &H77 &H65 &H72 &H74 &H3D '_______Leitwert= '51-66
  &H55 &H56 &H2D &H4C &H61 &H6D &H70 &H65 &H3D 'UV-Lampe= '67-75
  &H20 &H4C &H4C &H31 &H3D '_LL1= '76-80
  &H20 &H4C &H4C &H32 &H3D '_LL2= '81-85
  &H20 &H4C &H4C &H33 &H3D '_LL3= '86-90
tabend

Table TempTab "TempTab.Tab"
Table PhTab   "PhTab.Tab"

'syscode "fastbas.s19"
